# In case of running this script more than once: delete existing profiles
netsh mbn delete profile interface=* name="RTKMobile"

# Location of the xml file
$XMLFile = "RTKMobileAPN.xml"

$KORE_ID = "8910390"
$KORE_APN_NAME = "data.apn.name"
$FLOLIVE_ID = "8935711"
$FLOLIVE_APN_NAME = "flolive.net"

# Get Sim ID
$mbninfo = netsh mbn show readyinfo * | Out-String
echo $mbninfo

$subNsimIDs = [regex]::Matches($mbninfo, '(?<=Id\s*:).+?(?=\s)'.Trim()).value
echo $subNsimIDs

# $simid = (Select-String '(?<num>\d{1,19})' -InputObject $mbninfo)[0].matches[0].value 
echo $simid

$provider = $subNsimIDs[1].Substring(0,8).trim()
echo $provider
$provider_name = ""
if ($provider -eq $KORE_ID) {
  $provider_name = $KORE_APN_NAME
  echo "KORE"
}
elseif ($provider -eq $FLOLIVE_ID) {
  $provider_name = $FLOLIVE_APN_NAME
  echo "FLOLIVE"
}
else {
  echo "unknown provider"
  exit
}

# Add Provider AccessString/APN name to the XML file
$xml = [xml](Get-Content $XMLFile)
$xml.MBNProfileExt.Context.AccessString = $provider_name
$xml.Save($XMLFile)

# Add Subscriber ID to the XML file
$xml = [xml](Get-Content $XMLFile)
$xml.MBNProfileExt.SubscriberId = $subNsimIDs[0]
$xml.Save($XMLFile)

# Add SIM ICC ID to the XML file
$xml = [xml](Get-Content $XMLFile)
$xml.MBNProfileExt.SimIccID = $subNsimIDs[1]
$xml.Save($XMLFile)

# Pop-up PIN-code and Enable the modem
#$pin = Read-Host -Prompt 'Geef je PIN-code in (let op, u heeft maximaal 3 pogingen)'

# Add Profile
$IsOk = netsh mbn add profile interface=* name="RTKMobileAPN.xml"

$WindowTitle = "Add RTKMobile Profile"

Add-Type -AssemblyName PresentationFramework 
# Error Check
if ($IsOk -eq "") { 
  echo 'Profile installed successfully'
}
elseif ($IsOk[0] -like "*not present*") { 
  echo 'Unable to install profile. Please unlock the mobile connection and try again!'
  echo $IsOk
}
else {
  exit 
# echo $IsOk
}

#if ($IsOk -eq "") { 
#  [System.Windows.Forms.MessageBox]::Show('Profile installed successfully', $WindowTitle)
#} elseif ($IsOk[0] -like "*not present*") { 
#  [System.Windows.Forms.MessageBox]::Show('Unable to install profile. Please unlock the mobile connection and try again!', $WindowTitle)
#} else {
#  [System.Windows.Forms.MessageBox]::Show("Error", $WindowTitle)
#}

Read-Host -Prompt "Press Enter to exit"